Attribute VB_Name = "modProgram"
Option Explicit


'Form ndern
    Public Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
    Public Declare Function CreateRoundRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal X3 As Long, ByVal Y3 As Long) As Long
'/Form ndern

'Form immer im Vordergrund
    Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
    Private Const SWP_NOSIZE = &H1
    Private Const SWP_NOMOVE = &H2
    Private Const HWND_TOPMOST = -1
    Private Const HWND_NOTOPMOST = -2
'/Form immer im Vordergrund

'INI-Dateien schreiben
    Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
    Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
'/INI-Dateien schreiben

'Internet
    Private Declare Function RasEnumConnections Lib "RasApi32.DLL" Alias "RasEnumConnectionsA" (lpRasCon As Any, lpcb As Long, lpcConnections As Long) As Long
    Private Declare Function RasGetConnectStatus Lib "RasApi32.DLL" Alias "RasGetConnectStatusA" (ByVal hRasCon As Long, lpStatus As Any) As Long
    
    Const RAS_MaxEntryName = 256
    Const RAS_MaxDeviceType = 16
    Const RAS_MaxDeviceName = 32
    
    Private Type RASType
        dwSize As Long
        hRasCon As Long
        szEntryName(RAS_MaxEntryName) As Byte
        szDeviceType(RAS_MaxDeviceType) As Byte
        szDeviceName(RAS_MaxDeviceName) As Byte
    End Type
    
    Private Type RASStatusType
        dwSize As Long
        RasConnState As Long
        dwError As Long
        szDeviceType(RAS_MaxDeviceType) As Byte
        szDeviceName(RAS_MaxDeviceName) As Byte
    End Type
'/Internet

'Mauszeiger einfangen
    Public Declare Sub ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI)
    Public Declare Sub ClipCursor Lib "user32" (lpRect As Any)
    Public Declare Sub GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT)
    Public Declare Sub OffsetRect Lib "user32" (lpRect As RECT, ByVal X As Long, ByVal Y As Long)
'/Mauszeiger einfangen

'Tray Icon
    Private Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Long
    Private Type NOTIFYICONDATA
            cbSize As Long
            hwnd As Long
            uID As Long
            uFlags As Long
            uCallbackMessage As Long
            hIcon As Long
            szTip As String * 64
    End Type
    Private Const NIM_ADD = &H0
    Private Const NIM_DELETE = &H2
    Private Const NIM_MODIFY = &H1
    Private Const NIF_ICON = &H2
    Private Const NIF_MESSAGE = &H1
    Private Const NIF_TIP = &H4
    Public Const WM_MOUSEMOVE = &H200
    Public Const WM_RBUTTONUP = &H205
    Public Const WM_RBUTTONDOWN = &H204
    Dim TrayIcon As NOTIFYICONDATA
'/TrayIcon

'URL; Email
    Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
'/URL; Email

'Warten
    Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
'/Warten
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Public blnBirthday As Boolean 'TRUE = Wenn ich Geburtstag habe
Public blnDeveloper As Boolean 'Easter Egg, dass bei den Eigenschaften angezeigt wird.
Public blnDoEffect As Boolean 'Es drfen keine 2 Effekte gleichzeitig gemacht werden.
Public blnESC As Boolean 'Wenn die ESC-Taste gedrckt wird => TRUE; <> FALSE
Public blnMouseDown As Boolean 'Ist die Maus gedrckt oder nicht ?!?!
Public blnShapeStyle As Byte 'Werden die Formen ausgefllt oder nicht ??
Public bytPaintNumber As Byte 'Hier wird die spezifische Nummer gespeichert, was fr ein Tool aktiviert ist. (z.B. Pinsel, oder Radierer)
Public bytScreenShotDo As Byte 'Wie wird der Screenshot ausgelst ?
Public bytScreenShotKind As Byte 'Was fr ein Screenshot ?
Public bytScreenShotTime As Byte 'Wie lange braucht ein Screenshot.
Public bytSprayRadius As Byte 'Der Radius des Sprh Tools !
Public bytSprayThick As Byte 'Wie dicht es der Sprh Kreis ?
Public bytSubPaintNumber As Byte 'Hier wird die Unter-Nummer gespeichert
Public bytZoom As Byte 'Die Zoom-Strke wird hier zwischengepeichert
Public intAreaX1, intAreaX2, intAreaY1, intAreaY2 As Integer 'Der Auswahlbereich
Public intBrushWidth, intLineWidth, intRoundWidth As Integer 'Die Width Eigenschaften werden gepeichert
Public intMacTop As Integer 'Top der Form
Public intOldHeight, intOldWidth As Integer 'Die alte Bildhhe/breite wird hier gespeichert
Public intRealPicCount As Integer 'Reelle Zahl der Bilder
Public intSpraySteps As Integer
Public lngFileLenght As Long 'Die Gre des Bildes
Public lngPicNewColor, lngPicNewHeight, lngPicNewWidth As Long
Public strFullScreenPath As String 'Der Bildpfad fr das Vollbild-Bild wird hier gespeichert
Public strParameter As String 'Programm Parameter wird gespeichert
Public strPathName As String
Public strWinDir As String 'Das Pfad des Windows Verzeichnisses wird hier gespeichert
Public typError As typErrors
Public typINIValue As typINIValues
Public typPicInfo(255) As typPicInfos
Public typRect As RECT

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Public Type typPicInfos 'Hier werden die Informationen einer Datei gespeichert.
    blnChanged As Boolean
    strPath As String
End Type

Public Type typErrors 'Hier stehen die Informationen ber einen aufgetretenen Fehler.
    intStatus As Integer
    strDescription As String
    strSolution As String
End Type

Public Type typINIValues 'Hier werden die INI Eintrge gespeichert
    bytAskClearCB As Byte
    bytCapMouse As Byte
    bytDeleteClipBoard As Byte
    bytFrameIndex As Byte
    bytShowInfos As Byte
    bytShowSplash As Byte
    lngBGColor As Long
    lngHeight As Long
    lngMDIColor(1) As Long
    lngWidth As Long
    intScaleIndex As Integer
End Type

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Public Function FormOnTop(frmForm As Form)

        Call SetWindowPos(frmForm.hwnd, HWND_TOPMOST, 0&, 0&, 0&, 0&, SWP_NOSIZE Or SWP_NOMOVE)

End Function

Public Function FormNotOnTop(frmForm As Form)

    Call SetWindowPos(frmForm.hwnd, HWND_NOTOPMOST, 0&, 0&, 0&, 0&, SWP_NOSIZE Or SWP_NOMOVE)

End Function

Public Function GetShortFileName(strFileName As String, intLenght As Integer)

    If Len(strFileName) < intLenght Then
        GetShortFileName = strFileName
            Exit Function
    End If
    
    Dim intCount As Integer
    Dim intPointPos As Integer
    Dim strType As String
    
    For intCount = Len(strFileName) To 1 Step -1
        If Mid(strFileName, intCount, 1) = "." Then
            intPointPos = intCount
            GoTo gotGoOn
        End If
    Next
    
gotGoOn:
    strType = Right(strFileName, Len(strFileName) - intPointPos)
    
    strFileName = Left(strFileName, intLenght)
    strFileName = Left(strFileName, Len(strFileName) - Len(strType) - 2)
    GetShortFileName = strFileName & "~." & strType

End Function

Public Sub OpenSite(frmForm As Form, strURL As String)

    ShellExecute frmForm.hwnd, "open", strURL, "", "", 1

End Sub

Public Function WriteINI(Dateiname As String, DieSektion As String, DerEintrag As String, ByVal Wert As String) As Long

   WriteINI = WritePrivateProfileString(DieSektion, DerEintrag, Wert, Dateiname)
   
End Function

Function GetINIString(Dateiname As String, DieSektion As String, DerEintrag As String) As String

    Dim strTemp As String
    Dim strTempEntry As String

   strTemp = String(255, 0)
   strTempEntry = GetPrivateProfileString(DieSektion, DerEintrag, "", strTemp, 255, Dateiname)
   strTemp = Left(strTemp, strTempEntry)
   GetINIString = strTemp
   
End Function

Public Sub AddToTray(frm As Form, ToolTip As String, Icon)

    On Error Resume Next
    
    TrayIcon.cbSize = Len(TrayIcon)
    TrayIcon.hwnd = frm.hwnd
    TrayIcon.szTip = ToolTip & vbNullChar
    TrayIcon.hIcon = Icon
    TrayIcon.uID = vbNull
    TrayIcon.uFlags = NIF_ICON Or NIF_MESSAGE Or NIF_TIP
    TrayIcon.uCallbackMessage = WM_MOUSEMOVE
    
    Shell_NotifyIcon NIM_ADD, TrayIcon

End Sub

Public Sub RemoveFromTray()

    Shell_NotifyIcon NIM_DELETE, TrayIcon

End Sub

Public Function ClipCursorOnObject(pcbPicBox As PictureBox, ByVal intX As Integer, ByVal intY As Integer)

    Dim typRect As RECT
    Dim typPoint As POINTAPI
    
    Call GetClientRect(pcbPicBox.hwnd, typRect)

    typPoint.X = typRect.Left
    typPoint.Y = typRect.Top
    
    Call ClientToScreen(pcbPicBox.hwnd, typPoint)
    Call OffsetRect(typRect, typPoint.X, typPoint.Y)
    Call ClipCursor(typRect)

End Function

Public Function KeyPressAdd(Ascii As Integer) As Integer

    If Ascii >= 48 And Ascii <= 57 Then
        KeyPressAdd = Ascii
    ElseIf Ascii = 8 Then
        KeyPressAdd = Ascii
    Else
        KeyPressAdd = 0
    End If
    
End Function

Public Function DialUpStatus() As Boolean

  Dim RAS(255) As RASType, RASStatus As RASStatusType
  Dim lg&, lpcon&, Result&

    RAS(0).dwSize = 412
    lg = 256 * RAS(0).dwSize
    Result = RasEnumConnections(RAS(0), lg, lpcon)
    
    If lpcon = 0 Then
        DialUpStatus = False
    Else
        RASStatus.dwSize = 160
        Result = RasGetConnectStatus(RAS(0).hRasCon, RASStatus)
        If RASStatus.RasConnState = &H2000 Then
           DialUpStatus = True
        Else
           DialUpStatus = False
        End If
    End If
    
End Function


